function varargout = MainDialog(varargin)
% MainDialog MATLAB code for MainDialog.fig
%      MainDialog, by itself, creates a new MainDialog or raises the existing
%      singleton*.
%
%      H = MainDialog returns the handle to a new MainDialog or the handle to
%      the existing singleton*.
%
%      MainDialog('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MainDialog.M with the given input arguments.
%
%      MainDialog('Property','Value',...) creates a new MainDialog or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MainDialog_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MainDialog_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MainDialog

% Last Modified by GUIDE v2.5 21-Jul-2013 10:12:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MainDialog_OpeningFcn, ...
                   'gui_OutputFcn',  @MainDialog_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT


% --- Executes just before MainDialog is made visible.
function MainDialog_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Test1 (see VARARGIN)

% Choose default command line output for Test1
global globalHandles;

handles.output = hObject;

% Choose max or min problem
if get(handles.maxRadiobutton,'Value') == 1.0
    globalHandles.choice = 0;
else
    globalHandles.choice = 1; 
end

% Choose problem type(continuous or discrete) and update constraints
% options
if get(handles.conRadiobutton,'Value') == 1.0
    globalHandles.type = 0;
    set(handles.unconRadiobutton, 'Enable', 'on');
    set(handles.LERadiobutton, 'Enable', 'on');
    set(handles.LIeRadiobutton, 'Enable', 'on');
    set(handles.boxRadiobutton, 'Enable', 'off');
else
    globalHandles.type = 1; 
    set(handles.unconRadiobutton, 'Enable', 'on');
    set(handles.LERadiobutton, 'Enable', 'off');
    set(handles.LIeRadiobutton, 'Enable', 'off');
    set(handles.boxRadiobutton, 'Enable', 'on');
end

% Choose constraint and update solving method
if globalHandles.type == 0
    if get(handles.unconRadiobutton,'Value') == 1.0
        set(handles.methodPopupmenu, 'String', ('Continuous-GASS|Continuous-GASS with Averaging'));
        globalHandles.constraint = 0;
    elseif get(handles.LERadiobutton,'Value') == 1.0
        set(handles.methodPopupmenu, 'String', ('Continuous-GASS (Linear Equality Constraints)'));
        globalHandles.constraint = 1;
    else
        set(handles.methodPopupmenu, 'String', ('Continuous-GASS (Linear Inequality Constraints)'));
        globalHandles.constraint = 2;
    end
else
    if get(handles.unconRadiobutton,'Value') == 1.0
        set(handles.methodPopupmenu, 'String', ('Discrete Annealing-GASS'));
        globalHandles.constraint = 3;
    else
        set(handles.methodPopupmenu, 'String', ('Discrete-GASS'));
        globalHandles.constraint = 4;
    end
end

% Decide which method is chosen and update introduction edit
constraint = globalHandles.constraint;
switch constraint
    case 0
        choose =  get(handles.methodPopupmenu, 'Value');
    case 1
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 2
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 3
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 4
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
end
globalHandles.method = choose;
set(handles.introEdit, 'String', globalHandles.introMethods(choose));

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Test1 wait for user response (see UIRESUME)
% uiwait(handles.MainFigure);


% --- Outputs from this function are returned to the command line.
function varargout = MainDialog_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function objFunEdit_Callback(hObject, eventdata, handles)
% hObject    handle to objFunEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of objFunEdit as text
%        str2double(get(hObject,'String')) returns contents of objFunEdit as a double


% --- Executes during object creation, after setting all properties.
function objFunEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to objFunEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function maxUipanel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxUipanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% --- Executes when selected object is changed in maxUipanel.
function maxUipanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in maxUipanel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% Choose max or min problem
global globalHandles;
switch get(hObject,'Tag');
    case 'maxRadiobutton'
        globalHandles.choice = 0;
    case 'minRadiobutton'
        globalHandles.choice = 1; 
end


% --- Executes on button press in maxRadiobutton.
function maxRadiobutton_Callback(hObject, eventdata, handles)
% hObject    handle to maxRadiobutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of maxRadiobutton


% --- Executes on button press in minRadiobutton.
function minRadiobutton_Callback(hObject, eventdata, handles)
% hObject    handle to minRadiobutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of minRadiobutton

% --- Executes during object creation, after setting all properties.
function typeUipanel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to typeUipanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes when selected object is changed in typeUipanel.
function typeUipanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in typeUipanel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% Choose problem type(continuous or discrete) and update constraints
% options
global globalHandles;
set(handles.methodPopupmenu, 'value',1);
switch get(hObject,'Tag');
    case 'conRadiobutton'
        globalHandles.type = 0;
        set(handles.unconRadiobutton, 'Enable', 'on');
        set(handles.LERadiobutton, 'Enable', 'on');
        set(handles.LIeRadiobutton, 'Enable', 'on');
        set(handles.boxRadiobutton, 'Enable', 'off');
    case 'disRadiobutton'
        globalHandles.type = 1; 
        set(handles.unconRadiobutton, 'Enable', 'on');
        set(handles.LERadiobutton, 'Enable', 'off');
        set(handles.LIeRadiobutton, 'Enable', 'off');
        set(handles.boxRadiobutton, 'Enable', 'on');
end
set(handles.unconRadiobutton,'Value', 1.0);

% Update constraint and update solving method
if globalHandles.type == 0
    set(handles.methodPopupmenu, 'String', ('Continuous-GASS|Continuous-GASS with Averaging'));
    globalHandles.constraint = 0;
else
   set(handles.methodPopupmenu, 'String', ('Discrete Annealing-GASS'));
    globalHandles.constraint = 3;
end

% Decide which method is chosen and update introduction edit
constraint = globalHandles.constraint;
switch constraint
    case 0
        choose =  get(handles.methodPopupmenu, 'Value');
    case 3
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
end
globalHandles.method = choose;
set(handles.introEdit, 'String', globalHandles.introMethods(choose));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function constraintUipanel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to constraintUipanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes when selected object is changed in constraintUipanel.
function constraintUipanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in constraintUipanel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% Choose constraint and update solving method
global globalHandles;
set(handles.methodPopupmenu, 'value',1);
if globalHandles.type == 0
    if get(handles.unconRadiobutton,'Value') == 1.0
        set(handles.methodPopupmenu, 'String', ('Continuous-GASS|Continuous-GASS with Averaging'));
        globalHandles.constraint = 0;
    elseif get(handles.LERadiobutton,'Value') == 1.0
        set(handles.methodPopupmenu, 'String', ('Continuous-GASS (Linear Equality Constraints)'));
        globalHandles.constraint = 1;
    else
        set(handles.methodPopupmenu, 'String', ('Continuous-GASS (Linear Inequality Constraints)'));
        globalHandles.constraint = 2;
    end
else
    if get(handles.unconRadiobutton,'Value') == 1.0
        set(handles.methodPopupmenu, 'String', ('Discrete Annealing-GASS'));
        globalHandles.constraint = 3;
    else
        set(handles.methodPopupmenu, 'String', ('Discrete-GASS'));
        globalHandles.constraint = 4;
    end
end

% Decide which method is chosen and update introduction edit
constraint = globalHandles.constraint;
switch constraint
    case 0
        choose =  get(handles.methodPopupmenu, 'Value');
    case 1
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 2
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 3
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 4
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
end
globalHandles.method = choose;
set(handles.introEdit, 'String', globalHandles.introMethods(choose));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function methodPopupmenu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to methodPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in methodPopupmenu.
function methodPopupmenu_Callback(hObject, eventdata, handles)
% hObject    handle to methodPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns methodPopupmenu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from methodPopupmenu

% Decide which method is chosen and update introduction edit
global globalHandles;
constraint = globalHandles.constraint;
switch constraint
    case 0
        choose =  get(handles.methodPopupmenu, 'Value');
    case 1
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 2
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 3
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 4
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
end
globalHandles.method = choose;
set(handles.introEdit, 'String', globalHandles.introMethods(choose));
guidata(hObject, handles);

% --- Executes on button press in parameterPushbutton.
function parameterPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to parameterPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% According to method chosen, call different parameter dialog
global globalHandles;
choose = globalHandles.method;
switch choose
    case {1, 2, 5, 6}
        if ~ishandle(globalHandles.advanceOptionDialog)
            globalHandles.advanceOptionDialog = BriefOptionDialog;
        end
        set(BriefOptionDialog, 'Visible', 'on');
    case {3, 4}
        if ~ishandle(globalHandles.advanceOptionDialog2)
            globalHandles.advanceOptionDialog2 = BriefOptionDialog2;
        end
        set(BriefOptionDialog2, 'Visible', 'on');
end

guidata(hObject, handles);


% --- Executes on button press in solvePushbutton.
function solvePushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to solvePushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalHandles;                   
mywait = 0;
currDir = pwd;
try
    % Choose max or min problem
    if get(handles.maxRadiobutton,'Value') == 1.0
        globalHandles.choice = 0;
    else
        globalHandles.choice = 1; 
    end
    
    % Decide which method is chosen and update introduction edit
    constraint = globalHandles.constraint;
    switch constraint
        case 0
            choose =  get(handles.methodPopupmenu, 'Value');
        case 1
            choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
        case 2
            choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
        case 3
            choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
        case 4
            choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    end
    globalHandles.method = choose;
    
    % Get correct objective function name
    funcName = get(handles.objFunEdit, 'String');
    while isempty(funcName)
        msgbox('Objective function cannot be empty','Bad Input','modal');
        waitfor(handles.objFunEdit, 'String');
        if ishandle(handles)
            funcName = get(handles.objFunEdit, 'String');
        else
            return;
        end
    end

    currDir = pwd;
    funcName = get(handles.objFunEdit, 'String');
    orgFile = fopen(strcat(funcName, '.m'), 'r');
    while orgFile == -1
        msgbox('Cannot find the function under current directory, please input again','Bad Input');
        waitfor(handles.objFunEdit, 'String');
        if ishandle(handles)
            funcName = get(handles.objFunEdit, 'String');
            orgFile = fopen(strcat(funcName, '.m'), 'r');
        else
            return;
        end
    end
    fclose(orgFile);
    
%     if (strcmp(funcName, 'flip_dejong5') || strcmp(funcName, 'dejong5')) && ()
%     end
    
    % Copy objective function to where algorithm located, delete it when
    % finish
    %copyfile(strcat(funcName,'.m'), 'C:\Users\Tishin\Desktop\GASS_GUI', 'f');
    %cd('C:\Users\Tishin\Desktop\GASS_GUI');

    
    func = str2func(funcName);
    choice = globalHandles.choice;
    
    % Set parameters and solve the objective function
    switch choose
        case 1
            % Set parameters
            N=globalHandles.parameter1(1);  % number of samples
            K=globalHandles.parameter1(2); % number of maxmal iterations
            A=globalHandles.parameter1(3);
            M=globalHandles.parameter1(4);
            Hl=globalHandles.parameter1(5);
            initlow=globalHandles.parameter1(6);
            rho=globalHandles.parameter1(7);
            alpha=globalHandles.parameter1(8);
            step=globalHandles.parameter1(9);
            inithigh=globalHandles.parameter1(10);
            
            H_GASS = zeros(A, K);
            X_GASS = zeros(A, M);
            iterations = zeros(A,1);
            mywait = waitbar(0,'Under calculation, please wait...');
            
            % Solve objective function
            for j=1:A
                disp(j)
                [myflag, iter, S1,H1,X1]=GASS(N, K, func, M, Hl, initlow,inithigh, rho,alpha, step,choice);
                waitbar(j/A,mywait);
                H_GASS(j,:)=H1;
                X_GASS(j,:)=X1(length(H1),:);
                iterations(j) = iter;
                clear H1 X1;
                if myflag == 0
                    close(mywait);
                    return;
                end
            end
            if ishandle(mywait)
                close(mywait);
            end
            H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
            % Set optimal value and optimal solutions, iterations
            globalHandles.optimalValue = H_GASS;
            globalHandles.optimalSolution = X_GASS;
            globalHandles.iterations = mean(iterations);
            
            figure
            semilogy(S1,H_GASS_a)
            title([func2str(func) ' function']);
            xlabel('Total sample size');
            ylabel('Function value');
            legend('Continuous-GASS');
            %axis([0 S1(end)]);
        case 2
            % Set parameters
            N=globalHandles.parameter2(1);  % number of samples
            K=globalHandles.parameter2(2); % number of maxmal iterations
            A=globalHandles.parameter2(3);
            M=globalHandles.parameter2(4);
            Hl=globalHandles.parameter2(5);
            initlow=globalHandles.parameter2(6);
            rho=globalHandles.parameter2(7);
            alpha=globalHandles.parameter2(8);
            step=globalHandles.parameter2(9);
            c=globalHandles.parameter2(10);
            inithigh=globalHandles.parameter2(11);
            
            H_GASS = zeros(A, K);
            X_GASS = zeros(A, M);
            iterations = zeros(A,1);
            mywait = waitbar(0,'Under calculation, please wait...');
            
            % Solve objective function
            for j=1:A
                disp(j)
                [myflag, iter, S1,H1,X1]=GASS_avg(N, K, func, M, Hl, initlow,inithigh, rho,alpha, step,c,choice);
                waitbar(j/A,mywait);
                H_GASS(j,:)=H1;
                X_GASS(j,:)=X1(length(H1),:);
                iterations(j) = iter;
                clear H1 X1;
                if myflag == 0
                    close(mywait);
                    return;
                end
            end
            if ishandle(mywait)
                close(mywait);
            end
            H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
            % Set optimal value and optimal solutions, iterations
            globalHandles.optimalValue = H_GASS;
            globalHandles.optimalSolution = X_GASS;
            globalHandles.iterations = mean(iterations);
            
            figure
            semilogy(S1,H_GASS_a)
            title([func2str(func) ' function']);
            xlabel('Total sample size');
            ylabel('Function value');
            legend('Continuous-GASS with Averaging');
            %axis([0 S1(end)]);
        case 3
            % Set parameters
            N=globalHandles.parameter3(1);  % number of samples
            K=globalHandles.parameter3(2); % number of maxmal iterations
            A=globalHandles.parameter3(3);
            M1=globalHandles.parameter3(4);
            M2=globalHandles.parameter3(5);
            Hl=globalHandles.parameter3(6);
            rho=globalHandles.parameter3(7);
            alpha=globalHandles.parameter3(8);
            step=globalHandles.parameter3(9);
            
            H_GASS = zeros(A, K);
            X_GASS = zeros(A, M1*M2);
            iterations = zeros(A,1);
            mywait = waitbar(0,'Under calculation, please wait...');
            
            % Solve objective function
            for j=1:A
                disp(j)
                [myflag, iter, S1,H1,X1]=GSS(N, K, func, M1, M2,Hl, rho,alpha, step,choice);
                waitbar(j/A,mywait);
                H_GASS(j,:)=H1;
                X_GASS(j,:)=X1(length(H1),:);
                iterations(j) = iter;
                clear H1 X1;
                if myflag == 0
                    close(mywait);
                    return;
                end
            end
            if ishandle(mywait)
                close(mywait);
            end
            H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
            % Set optimal value and optimal solutions, iterations
            globalHandles.optimalValue = H_GASS;
            globalHandles.optimalSolution = X_GASS;
            globalHandles.iterations = mean(iterations);
            
            figure
            semilogy(S1,H_GASS_a)
            title([func2str(func) ' function']);
            xlabel('Total sample size');
            ylabel('Function value');
            legend('Continuous-GASS with Averaging');
        case 4
            % Set parameters
            N=globalHandles.parameter4(1);  % number of samples
            K=globalHandles.parameter4(2); % number of maxmal iterations
            A=globalHandles.parameter4(3);
            M1=globalHandles.parameter4(4);
            M2=globalHandles.parameter4(5);
            Hl=globalHandles.parameter4(6);
            rho=globalHandles.parameter4(7);
            alpha=globalHandles.parameter4(8);
            step=globalHandles.parameter4(9);
            
            H_GASS = zeros(A, K);
            X_GASS = zeros(A, M1*M2);
            iterations = zeros(A,1);
            mywait = waitbar(0,'Under calculation, please wait...');
            
            % Solve objective function
            for j=1:A
                disp(j)
                [myflag, iter, S1,H1,X1]=GSS1(N, K, func, M1, M2,Hl, rho,alpha, step,choice);
                waitbar(j/A,mywait);
                H_GASS(j,:)=H1;
                X_GASS(j,:)=X1(length(H1),:);
                iterations(j) = iter;
                clear H1 X1;
                if myflag == 0
                    close(mywait);
                    return;
                end
            end
            if ishandle(mywait)
                close(mywait);
            end
            H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
            % Set optimal value and optimal solutions, iterations
            globalHandles.optimalValue = H_GASS;
            globalHandles.optimalSolution = X_GASS;
            globalHandles.iterations = mean(iterations);
            
            figure
            semilogy(S1,H_GASS_a)
            title([func2str(func) ' function']);
            xlabel('Total sample size');
            ylabel('Function value');
            legend('Continuous-GASS with Averaging');
        case 5
            % Set parameters
            N=globalHandles.parameter5(1);  % number of samples
            K=globalHandles.parameter5(2); % number of maxmal iterations
            A=globalHandles.parameter5(3);
            M=globalHandles.parameter5(4);
            Hl=globalHandles.parameter5(5);
            initlow=globalHandles.parameter5(6);
            D=globalHandles.parameter5(7);
            rho=globalHandles.parameter5(8);
            alpha=globalHandles.parameter5(9);
            step=globalHandles.parameter5(10);
            temp=globalHandles.parameter5(11);
            inithigh=globalHandles.parameter5(12);
            
            H_GASS = zeros(A, K);
            X_GASS = zeros(A, M);
            iterations = zeros(A,1);
            mywait = waitbar(0,'Under calculation, please wait...');
            
            % Solve objective function
            for j=1:A
                disp(j)
                [myflag, iter, S1,H1,X1]=SA_dist(N, K, func, M, Hl, initlow,inithigh,D, alpha, step,temp,choice);
                waitbar(j/A,mywait);
                H_GASS(j,:)=H1;
                X_GASS(j,:)=X1(length(H1),:);
                iterations(j) = iter;
                clear H1 X1;
                if myflag == 0
                    close(mywait);
                    return;
                end
            end
            if ishandle(mywait)
                close(mywait);
            end
            H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
            % Set optimal value and optimal solutions, iterations
            globalHandles.optimalValue = H_GASS;
            globalHandles.optimalSolution = X_GASS;
            globalHandles.iterations = mean(iterations);
            
            figure
            semilogy(S1,H_GASS_a)
            title([func2str(func) ' function']);
            xlabel('Total sample size');
            ylabel('Function value');
            legend('Discrete Annealing-GASS');
            %axis([0 S1(end)]);
        case 6
            % Set parameters
            N=globalHandles.parameter6(1);  % number of samples
            K=globalHandles.parameter6(2); % number of maxmal iterations
            A=globalHandles.parameter6(3);
            M=globalHandles.parameter6(4);
            Hl=globalHandles.parameter6(5);
            initlow=globalHandles.parameter6(6);
            D=globalHandles.parameter6(7);
            rho=globalHandles.parameter6(8);
            alpha=globalHandles.parameter6(9);
            step=globalHandles.parameter6(10);
            inithigh=globalHandles.parameter6(11);
            
            H_GASS = zeros(A, K);
            X_GASS = zeros(A, M);
            iterations = zeros(A,1);
            mywait = waitbar(0,'Under calculation, please wait...');
            
            % Solve objective function
            for j=1:A
                disp(j)
                [myflag, iter, S1,H1,X1]=GASS_dis(N, K, func, M, Hl, initlow,inithigh,D, rho,alpha, step,choice);
                waitbar(j/A,mywait);
                H_GASS(j,:)=H1;
                X_GASS(j,:)=X1(length(H1),:);
                iterations(j) = iter;
                clear H1 X1;
                if myflag == 0
                    close(mywait);
                    return;
                end
            end
            if ishandle(mywait)
                close(mywait);
            end
            H_GASS_a=sum(H_GASS,1)/A; % average of the function values for 100 independent runs
            % Set optimal value and optimal solutions, iterations
            globalHandles.optimalValue = H_GASS;
            globalHandles.optimalSolution = X_GASS;
            globalHandles.iterations = mean(iterations);
            
            figure
            semilogy(S1,H_GASS_a)
            title([func2str(func) ' function']);
            xlabel('Total sample size');
            ylabel('Function value');
            legend('Discrete-GASS');
            %axis([0 S1(end)]);
    end
    globalHandles.flag = myflag;
    set(handles.MainFigure, 'Visible', 'off');
    run ResultDialog;
catch ME
%       myME.identifier = ME.identifier;
%       myME.message = ME.message;
%       myME.stack = ME.stack(1, 1);
%       myME.stack.file = [currDir '\' funcName '.m'];
%       if ishandle(mywait)
%           close(mywait);
%       end
%       clear ME;
%       error(myME);
        % Output error information
        if strcmp(ME.identifier, 'MATLAB:dimagree')
             warndlg('The objective function does not have the specified dimension! Please check the parameter setting!', 'Objective Function Error');
        else
              myME.identifier = ME.identifier;
              myME.message = ME.message;
              myME.stack = ME.stack(1, 1);
              myME.stack.file = [currDir '\' funcName '.m'];
              if ishandle(mywait)
                  close(mywait);
              end
              clear ME;
              error(myME);
        end
        if ishandle(mywait)
           close(mywait);
        end
        return;
end

guidata(hObject, handles);


% --- Executes on button press in closePushbutton.
function closePushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to closePushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 close ALL;



function introEdit_Callback(hObject, eventdata, handles)
% hObject    handle to introEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of introEdit as text
%        str2double(get(hObject,'String')) returns contents of introEdit as a double


% --- Executes during object creation, after setting all properties.
function introEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to introEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%set(hObject, 'String', handles.introMethods(1));
guidata(hObject, handles);


% --- Executes on key press with focus on methodPopupmenu and none of its controls.
function methodPopupmenu_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to methodPopupmenu (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
global globalHandles;
constraint = globalHandles.constraint;
switch constraint
    case 0
        choose =  get(handles.methodPopupmenu, 'Value');
    case 1
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 2
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 3
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 4
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
end
globalHandles.method = choose;
set(handles.introEdit, 'String', globalHandles.introMethods(choose));
guidata(hObject, handles);


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over methodPopupmenu.
function methodPopupmenu_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to methodPopupmenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global globalHandles;
constraint = globalHandles.constraint;
switch constraint
    case 0
        choose =  get(handles.methodPopupmenu, 'Value');
    case 1
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 2
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 3
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
    case 4
        choose =  get(handles.methodPopupmenu, 'Value') + 1 + constraint;
end
globalHandles.method = choose;
set(handles.introEdit, 'String', globalHandles.introMethods(choose));
guidata(hObject, handles);
