function main(varargin)
% This is the entrance of the software, it add the software path to the
% working directory and call main dialog
warning off;
% If you pack this software and install the software package, you can
% remove the following sentence because it will add the software
% installation route to the working directory
addpath('C:\Users\Tishin\Desktop\GASS_GUI');

% Use global handle to operate all GUIs and parameters
global globalHandles;

% Initialize parameters of each mehtod
globalHandles.parameter1 = zeros(1,10);
globalHandles.parameter2 = zeros(1,11);
globalHandles.parameter3 = zeros(1,9);
globalHandles.parameter4 = zeros(1,9);
globalHandles.parameter5 = zeros(1,12);
globalHandles.parameter6 = zeros(1,11);

globalHandles.parameter1(1) = 1000;
globalHandles.parameter1(2) = 500;
globalHandles.parameter1(3) = 5;
globalHandles.parameter1(4) = 50;
globalHandles.parameter1(5) = -2e6;
globalHandles.parameter1(6) = -30;
globalHandles.parameter1(7) = 0.05;
globalHandles.parameter1(8) = 1;
globalHandles.parameter1(9) = 0.05;
globalHandles.parameter1(10) = 30;

globalHandles.parameter2(1) = 1000;
globalHandles.parameter2(2) = 500;
globalHandles.parameter2(3) = 5;
globalHandles.parameter2(4) = 50;
globalHandles.parameter2(5) = -2e6;
globalHandles.parameter2(6) = -30;
globalHandles.parameter2(7) = 0.05;
globalHandles.parameter2(8) = 1;
globalHandles.parameter2(9) = 0.05;
globalHandles.parameter2(10) = 0.1;
globalHandles.parameter2(11) = 30;

globalHandles.parameter3(1) = 1000;
globalHandles.parameter3(2) = 300;
globalHandles.parameter3(3) = 5;
globalHandles.parameter3(4) = 10;
globalHandles.parameter3(5) = 5;
globalHandles.parameter3(6) = -2e6;
globalHandles.parameter3(7) = 0.05;
globalHandles.parameter3(8) = 1;
globalHandles.parameter3(9) = 0.05;

globalHandles.parameter4(1) = 1000;
globalHandles.parameter4(2) = 300;
globalHandles.parameter4(3) = 5;
globalHandles.parameter4(4) = 10;
globalHandles.parameter4(5) = 5;
globalHandles.parameter4(6) = -2e6;
globalHandles.parameter4(7) = 0.05;
globalHandles.parameter4(8) = 1;
globalHandles.parameter4(9) = 0.05;

globalHandles.parameter5(1) = 100;
globalHandles.parameter5(2) = 300;
globalHandles.parameter5(3) = 5;
globalHandles.parameter5(4) = 50;
globalHandles.parameter5(5) = -2e6;
globalHandles.parameter5(6) = -50;
globalHandles.parameter5(7) = 201;
globalHandles.parameter5(8) = 0.1;
globalHandles.parameter5(9) = 100;
globalHandles.parameter5(10) = 0.05;
globalHandles.parameter5(11) = 5000;
globalHandles.parameter5(12) = 50;

globalHandles.parameter6(1) = 1000;
globalHandles.parameter6(2) = 300;
globalHandles.parameter6(3) = 5;
globalHandles.parameter6(4) = 50;
globalHandles.parameter6(5) = -2e6;
globalHandles.parameter6(6) = -10;
globalHandles.parameter6(7) = 41;
globalHandles.parameter6(8) = 0.05;
globalHandles.parameter6(9) = 0.1;
globalHandles.parameter6(10) = 0.05;
globalHandles.parameter6(11) = 10;

% Set names of each method
globalHandles.methods = cell(1, 6);
globalHandles.methods(1) = {'Continuous-GASS'};
globalHandles.methods(2) = {'Continuous-GASS with Averaging'};
globalHandles.methods(3) = {'Continuous-GASS (Linear Equality Constraints)'};
globalHandles.methods(4) = {'Continuous-GASS (Linear Inequality Constraints)'};
globalHandles.methods(5) = {'Discrete Annealing-GASS'};
globalHandles.methods(6) = {'Discrete-GAS'};


% Set introduction of each method
globalHandles.introMethods = cell(1, 6);
globalHandles.introMethods(1) = {'Using Continuous-GASS to find high quality solutions of continuous unconstrained multivariate function with multiple local optima, little structural properties (e.g. di fferentiability and convexity) or black-box optimization problems.'};
globalHandles.introMethods(2) = {'Using Continuous-GASS with Averaging to find high quality solutions of continuous unconstrained multivariate function with multiple local optima, little structural properties (e.g. di fferentiability and convexity) or black-box optimization problems. It uses Polyak averaging technique in stochastic approximation to accelerate the convergence rate of GASS.'};
globalHandles.introMethods(3) = {'Using Continuous-GASS (Linear Equality Constraints) to get optimal value of continuous multivariate optimization with linear equality constraints with multiple local optima, little structural properties (e.g. di fferentiability and convexity) or black-box optimization problems.'};
globalHandles.introMethods(4) = {'Using Continuous-GASS (Linear Inequality Constraints) to get optimal value of continuous multivariate optimization with linear inequality constraints with multiple local optima, little structural properties (e.g. di fferentiability and convexity) or black-box optimization problems.'};
globalHandles.introMethods(5) = {'Using Discrete-Annealing-GASS to find high quality solutions of discrete multivariate function with box constraints with multiple local optima, little structural properties (e.g. di fferentiability and convexity) or black-box optimization problems. It uses Boltzmann distribution as the parameterized probabilistic model in GASS, and adaptively updates the temperature schedule according to the current performance of the algorithm by a gradient-based method.'};
globalHandles.introMethods(6) = {'Using Discrete-GASS to find high quality solutions of discrete multivariate function with box constraints with multiple local optima, little structural properties (e.g. di fferentiability and convexity) or black-box optimization problems.'};

% Add main dialog and option dialogs
globalHandles.mainDialog = MainDialog;
globalHandles.optionDialog = 0;
globalHandles.optionDialog2 = 0;
globalHandles.advanceOptionDialog = 0;
globalHandles.advanceOptionDialog2 = 0;